# Assumptions, Limitations and Quirks
Here we present a list of modelling assumptions that flow-through into both the code implementation and output. We also summarise some limitations and quirks of the codebase itself, and what effects these have on simulation output. Some of the (latter) points are limitations that could be turned into substantial developments to the package if users desire (e.g. implementing complex contagion).

Assumptions and limitations of the bipartite network objects that the `networkcontagion` library runs on are not detailed here, but we do include short documentation about how `cobin` interacts with the [network objects](cobin_bipartite). Further documentation on the network as a whole will be linked here once developed.

## Transmission in hospitals not modelled
We know that there have been many recorded instances of spread within hospitals (e.g. between patients, between patients and staff or between patients and visitors). However, both the underlying network objects the library runs on and the codebase itself, do not currently have any spread allowed between individuals in a hospital and outside. We allow for a small chance of quarantined individuals to ignore quarantine rules and instead . However, because hospitals are not modelled as actual nodes in the network objects, there is no way to model spread within them.

## Transmission in isolation facilities not modelled
Similarly to hospitals, we know that there have been recorded instances of spread within isolation facilities (e.g. between isolated individuals, between staff and isolated individuals or between isolated individuals and visitors). Like with hospitals, the network and model currently do not have the ability to simulate these transmission events.

## Rule adherence depends on interaction not individual
Rule-adherence is drawn at the interaction level, and not the individual level. This means that individuals tend to not have tractable adherence. This is somewhat at odds with reality, where only a small group of individuals contribute towards a large amount of rule non-adherence.

## Markovian dynamics and exponential time-in-state distributions
For all states in the disease-progression-pathway, excluding the latent period, we assume that the time-in-state distributions are exponential and so the jump transitions are a Markovian process, depending only on the current system state. Furthermore, the associated rate parameters must then be constant. This is also true of ordinary differential equations when considered as mean-field approximations to stochastic models. However, the exponential assumption is not a good approximation for many processes. For example, it means an individual could instantaneously recover or take an infinite time to recover, neither of which is realistic. In addition, the infectivity of individuals is constant for a given disease state. So, rather than a continuously-varying level of infectivity, we instead represent this via discrete levels of infectiousness associated with discrete "disease progression" states.

## Group homogeneity
We allow for different infection contexts represented by different types of group nodes/interaction nodes (including schools, workplaces, dwellings and community interactions). However, although we assume that each type of interaction context has a different transmission risk (e.g. spread is likely higher in dwellings than in workplaces), we assume that within each type of context groups are otherwise indistinguishable and hence have the same transmission risk associated (e.g. two distinct schools have the same transmission risk associated with them). The only differences in transmission risk within groups of the same type would be from the number and characteristics of the individuals interacting within those groups.

## Homogeneity of individuals with respect to testing, isolation, quarantine, contact tracing, vaccination etc.
Our model allows for some heterogeneity in individual behaviour, e.g. we have 'testers' and 'non-testers' and 'vaccinated' or 'unvaccinated' (with different numbers of doses). However, beyond these binary types such as testers/non-testers and other age dependence of rates, we treat individuals as homogeneous in many respects. For example, among individuals who test, we assume they all have the same ability to seek a test. Even more importantly, we assume that individuals who are contact traced and told to isolate or quarantine are equally able to do so. Some component of imperfect isolation/quarantine is captured indirectly via ‘leak’ parameters, but these do not currently depend on e.g. age, ethnicity or socioeconomic status. This means we do not represent individuals who are unable to effectively self-isolate. 

## Homogeneity of individuals with respect to vaccination and previous infection
We also have homogeneity of vaccine and prior-infection response, i.e. individuals with the same number of doses/past-infections have the same protection, and the level of protection changes over time in the same way for all individuals. There may be interacting effects between certain individual demographics and infection/vaccine-conferred protection that is not covered by this homogeneity.

## Limitless capacity on NPI/TTIQ policy resources
It is known that there are resource capacities for NPI/TTIQ implementation. For example, a limited amount of time can be allocated to contact tracing in a centralised system. We do not currently model these resource constraints.

## Poor characterisation of non-compliance
Non-compliance with NPIs, specifically non-compliance with isolation, is modelled such that each non-compliance event is independent. This does not reflect consistent patterns of non-compliance of particular individuals - i.e. non-compliance is currently represented as homogeneous across individuals and non-compliance events. Also, all individuals that are self-isolating (for any reason) will have the same non-compliance profile.

## Parameter issues and inter-relationship between parameters and network object
This is more of a general note/limitation around parameters, networks and their interactions. Firstly, due to the size and complexity of the model, almost all parameters have large and non-linear effects on observed output. For example, increasing the transmission rate by a small amount leads to a large change in the realised infection dynamics. Further, effects that might be expected to be similar (such as having a 50% reduction in transmission in schools during a lockdown vs. having a 50% closure of schools during a lockdown) can often instead have very varying effects (in this case because closing schools can cause a large reduction in the degree and connectedness of nodes in the network which leads to a much larger reduction in cases compared to a reduction in transmission rate).

Similarly, small changes in model/code logic or assumptions can also lead to large changes in observed output.

Parameters are also intrinsically linked to the networks that they are calibrated to; using the same parameters (especially for transmission-related parameters) on a different network object will lead to different results. For example, using the provided vignette configs that have fairly-low spread on the example networks on a larger/denser network may instead lead to a much larger infection wave.

## Hazard functions (bounds and infinities)
Currently there is only one non-constant hazard function/transition rate (for the latent period of the disease) which is a gamma function. The gamma function has no upper bound and the Gillespie Max algorithm requires a maximum rate to employ rejection sampling. We have found that this is not a problem for the time period and contagion configurations simulated, as all individuals transition out of the state before the hazard becomes 'too unbounded', but it is worth raising this as a potential issue. If non-Markovian/time-dependent hazard functions are desired for other transition processes, then max rates and implementation will have to be considered carefully (perhaps with a better dynamic upper-bound within the rate function calculation). Similarly, although we do not currently use any hazard functions with values of zero, some commonly used hazard functions have a value of zero at some points in their distribution (for example the Weibull function is zero at a time of zero). Caution therefore has to be given to simulating whether events with these types of hazards can occur at time values of/near zero.

## Simple Contagion
Currently the model only allows for the simulation of simple contagion (one disease). This means that the simultaneous spread of different diseases, or even different variants of the same contagion, cannot be modelled at the same time. In the case of COVID-modelling, this means that explicit variants cannot be modelled at the same time, and parameters instead are changed to represent 'variant soups' that are present at a certain time period. It would be possible, though difficult, to implement complex contagion if a user wished.

## Static transmission networks
There is increasing evidence that using a temporally-changing network may better encapsulate the changing interaction behaviour of individuals over time. The networkcontagion codebase is built around using static networks produced by a different repository. It might be useful to extend the codebase to run on temporally changing networks (for example for a different simulation of lockdowns).

## Consecutive model runs
Although originally available, adding the ability to restart simulations from a dumped state has removed the ability to run simulations consecutively without re-running the Python script. However, using a simple shell script allows for the consecutive running of simulations (for example with a for loop).